package com.softing.opc.client.enums;

import com.softing.opc.client.impl.jna.OTClient;

public enum EnumResultCode {

	S_OK (OTClient.S_OK),
	S_FALSE (OTClient.S_FALSE),
	E_NOTIMPL (OTClient.E_NOTIMPL),
	E_OUTOFMEMORY (-2147024882),
	
	E_INVALIDARG (-2147024809),
	E_NOINTERFACE (-2147467262),
	E_ACCESSDENIED (-2147024891),
	E_FAIL (OTClient.E_FAIL),
	
	E_UNEXPECTED (-2147418113),
	CONNECT_E_NOCONNECTION (-2147220992),
	CONNECT_E_ADVISELIMIT (-2147220991),
	DISP_E_TYPEMISMATCH (-2147352571),
	
	DISP_E_OVERFLOW (-2147352566),
	E_INVALIDHANDLE (OTClient.OT_E_OPC_INVALIDHANDLE),
	E_BADTYPE (OTClient.OT_E_OPC_BADTYPE),
	E_PUBLIC (OTClient.OT_E_OPC_PUBLIC),
	
	E_BADRIGHTS (OTClient.OT_E_OPC_BADRIGHTS),
	E_UNKNOWNITEMID (OTClient.OT_E_OPC_UNKNOWNITEMID),
	E_INVALIDITEMID (OTClient.OT_E_OPC_INVALIDITEMID),
	E_INVALIDFILTER (OTClient.OT_E_OPC_INVALIDFILTER),
	
	E_UNKNOWNPATH (OTClient.OT_E_OPC_UNKNOWNPATH),
	E_RANGE (OTClient.OT_E_OPC_RANGE),
	E_DUPLICATENAME (OTClient.OT_E_OPC_DUPLICATENAME),
	S_UNSUPPORTEDRATE (OTClient.OT_S_OPC_UNSUPPORTEDRATE),
	
	S_CLAMP (OTClient.OT_S_OPC_CLAMP),
	S_INUSE (OTClient.OT_S_OPC_INUSE),
	E_INVALIDCONFIGFILE (OTClient.OT_E_OPC_INVALIDCONFIGFILE),
	E_NOTFOUND (OTClient.OT_E_OPC_NOTFOUND),
	
	E_INVALID_PID (OTClient.OT_E_OPC_INVALID_PID),
	E_DEADBANDNOTSET (OTClient.OT_E_OPC_DEADBANDNOTSET),
	E_DEADBANDNOTSUPPORTED (OTClient.OT_E_OPC_DEADBANDNOTSUPPORTED),
	E_NOBUFFERING (OTClient.OT_E_OPC_NOBUFFERING),
	
	E_INVALIDCONTINUATIONPOINT (OTClient.OT_E_OPC_INVALIDCONTINUATIONPOINT),
	S_DATAQUEUEOVERFLOW (OTClient.OT_S_OPC_DATAQUEUEOVERFLOW),
	E_RATENOTSET (OTClient.OT_E_OPC_RATENOTSET),
	E_NOTSUPPORTED (OTClient.OT_E_OPC_NOTSUPPORTED);
	
	private final int resultCode;
	
	EnumResultCode(int value)
	{
		resultCode = (short)value;
	}
	
	public int toInt()
	{
		return resultCode;
	}
	
}
