## **Files installed by the OPC Toolkit setup**

The OPC Toolkit has a 3 layer approach.

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/ToolboxStructure.gif)

1.  The API layer with the programming interfaces for the application programmer
2.  The C interface of the Toolkit core
3.  The Toolkit core



The OPC Toolkit setup installs the following directory structure to the directory <Program files>\Softing\OPCToolkit\V4.4x :


|       |         | 
| ------------- |:-------------:|
| doc     | Online help files|
| Redist     | OPC Foundation OPC Core Components x86 and x64 redistributables (MSI installers)     |
| utilities | Utilities needed during the installation and compile process      |
| Windows     | OPC Toolkit files for the Windows platform |
| bin      | Library (.dll) files of VS2008, VS2010, VS2012, VS2013, VS2015 and VS2017 (for both 32-bit and 64-bit platforms)      |
| IISProxy | IIS / Apache proxy library      |
| legacy     | Library (.dll) files of VS2003 and VS2005 (only for 32-bit platforms) |
| ProjectWizard     | Project Wizard binary files      |
| C++| OPC Toolkit C++ API and samples        |
| lib     | C++ librarian (.lib) files for VS2008, VS2010, VS2012, VS2013, VS2015 and VS2017 (for both 32-bit and 64-bit platforms) |
| legacy     |C++ librarian (.lib) files for VS2003 and VS2005 (only for 32-bit platforms)      |
| samples | C++ sample applications and tutorials      |
| src     | Source code of the C++ API |
| core      | OPC Toolkit Core      |
| common | Common header and resource files      |
| include     | C include files of the Core API |
| lib     |  Core .lib files for VS2008, VS2010, VS2012, VS2013, VS2015 and VS2017 (for both 32-bit and 64-bit platforms)      |
| legacy | Core .lib files for VS2003 and VS2005 (only for 32-bit platforms)      |
| src      | Core source file. This directory is only available if you purchased and activated a source code license  |
| NET     | OPC Toolkit .NET API and samples      |
| samples | .NET sample applications and tutorials      |
| src | Source code of the .NET API      |


You can compile the API libraries with the project files located in the C++/src/ and NET/src/ directories.

### Note
```
Due to compatibility reasons and to avoid overwriting customer-modified source code
files, the source code licenses will no longer be upgraded when performing a Softing OPC Toolkit upgrade. The source code license
needs to be manually upgraded by activating the purchased source code licenses in License Manager.
```

**OPC Toolkit and 64-bit systems**

Applications made with the Softing OPC Toolkit run on 64-bit systems as 32-bit or 64-bit applications. The OPC Toolkit 4.4x has native 64-bit support.

The Softing OPC Toolkit installs in **Program Files (x86)** folder.

On 64 bit systems, TBNx needs to be compiled on the **AnyCPU** platform settings and should be deployed together with both 32-bit and 64-bit versions of the Toolkit Core.
