## **Update OPC Toolbox V4.3x Projects to OPC Toolkit V4.40**

Update OPC Toolbox V4.3x Projects to OPC Toolkit V4.40

### Summary

This article gives a brief description of the differences between the Softing OPC Toolbox V4.3x (or earlier) and Softing OPC Toolkit V4.40. It gives also some hints to the code changes you should make to migrate your developed OPC application based on Softing OPC Toolbox 4.3x to the Softing OPC Toolkit V4.40.

Because the .NET API of the OPC Toolkit (V4.40) has been changed due to navite 64 bit compiling resources and interoperability between 32 bit and 64 bit native OPC Clients and OPC Servers.

###  Update dependencies for .NET based projects.

For Microsoft Visual Studio 2008 (or later) projects the Softing Toolkit 4.40 provides support for x86 and x64 target machine. Softing OPC Toolkit 4.40 includes the TBNxx.dll libraries same as the previous toolbox versions. For all platform (x86 or x64) based application allong with the framework specific TBNxx.dll is library and OTBu.dll library, also the OTBux64.dll needs to be included.

The Object handles datatype was modified from IntPtr to uint in the TBNxx.dll library.

###  Migrate a 32 bit OPC project to 64 bit OPC project

**C++ based projects**

Softing OPC Toolkit 4.40 provides a new set of libraries for 64 bit applications. The Toolkit 4.40 API did not change from the previous version, therefore no code change is necesarry in the 32 bit project.

Go to Microsoft Visual Studio **Build -> Configuration Manager** create a new configuration x64, and copy settings from 32 bit project configuration. Go to **Project -> Properties**. In the project properties go to **Configuration Properties -> C\C++ -> Preprocesor** , change Prepocesore definition field, replace **WIN32** with **WIN64**. Next go to **Configuration Properties -> Linker -> Input**, on the Additional Dependencies field change the library name to the 64 bit library. ex: (TBCVS2010D.dll -> TBCVS2010Dx64.dll). Go to **Configuration Properties -> Linker -> Advanced** change Target Machine field from **MachineX86 (/MACHINE:X86)** to **MachineX64 (/MACHINE:X64)**

### Note
```
To succesfully build 64 bit projects make sure that you have instaled 64 bit compilers for Microsoft Visual 
Studio.
```
Update OPC Toolbox V4.3x Projects to OPC Toolkit V4.40

**.NET based projects**

Softing OPC Classic Toolkit 4.40 provides the possibility to run .NET based projects as native 64 bit applications. The Tookit functions API was modified from the previous Softing OPC Clasic Toolbox 4.3x, therefore some function arguments datatypes ware modified.

This is a list of elements that were modified in Softing OPC Classic Toolkit 4.40 .NET API:
|      Constructor          |Softing OPC Classic Toolbox 4.3x                         |Softing OPC Classic Toolkit 4.40                       |
|----------------|-------------------------------|-----------------------------|
|DaSession|(..., IntPtr aHandle)            |(..., uint aHandle)             |
|DaTransaction        |(..., uint aHandle)  `            |(..., uint aSessionHandle)        |
|AddressSpaceElement         |(..., IntPtr anObjectHandle, IntPtr aParentHandle)|(..., uint anObjectHandle, uint aParentHandle)  |
|DaAddressSpaceElement|(..., IntPtr anObjectHandle, IntPtr aParentHandle)            |(..., uint anObjectHandle, uint aParentHandle)             |
|AeAddressSpaceElement         |(..., IntPtr anObjectHandle, IntPtr aParentHandle) |(..., uint anObjectHandle, uint aParentHandle)            |
|DaRequest        |(..., IntPtr aSessionHandle, ... , IntPtr aRequestHandle)|(..., uint aSessionHandle, ... ,uint aRequestHandle)  |
<br><br>


**Method**|**Softing OPC Classic Toolbox 4.3x**|**Softing OPC Classic Toolkit 4.40**
:-----:|:-----:|:-----:
BrowseAeServerEventHandler|(..., IntPtr addressSpaceElementHandle, ...)|(..., uint addressSpaceElementHandle, ...)
BrowseDaServerEventHandler|(..., IntPtr addressSpaceElementHandle, ...)|(..., uint addressSpaceElementHandle, ...)
GetDaPropertiesEventHandler|(..., IntPtr addressSpaceElementHandle, ...)|(..., uint addressSpaceElementHandle, ...)
CreateInternalDaAddressSpaceElement|(..., IntPtr addressSpaceElementHandle, ...)|(..., uint addressSpaceElementHandle, ...)
CreateInternalAeAddressSpaceElement|(..., IntPtr addressSpaceElementHandle, ...)|(..., uint addressSpaceElementHandle, ...)
CreateRequest|(..., IntPtr aSessionHandle, ... , IntPtr aRequestHandle)|(..., uint addressSpaceElementHandle, ... ,uint aRequestHandle)
CreateTransaction|(... , IntPtr aSessionKey)|(... ,uint aSessionKey)
<br><br>
**Property**|**Softing OPC Classic Toolbox 4.3x**|**Softing OPC Classic Toolkit 4.40**
:-----:|:-----:|:-----:
ObjectHandle|IntPtr ObjectHandle { get; }|uint ObjectHandle { get; }
Handle|IntPtr Handle { get; }|uint Handle { get; }



### Some title

bdm