## **ValueQT Class**

The Softing Toolkit provides a class that represents the value of a process variable with its quality and the time it was obtained by the device or by the server's cache. The class is called **ValueQT** and stores information about:

-   the **value** of a process variable. It can be taken using the **Data** property (in .NET) or using the **getData** method (in C++).
    
-   the **quality** of the process variable's value. The quality can be good, bad or uncertain. The server will mark the value as bad, if there is, for example, no link to the device. It will mark it as uncertain if, for example, there is a link to the device but the value makes no sense because, for instance, there is a deviation from the measuring range.
    
    Also the quality contains further information about the value status. An example of this is the value Not Connected as a more precise explanation for the status Bad. In this case the quality of the value will be given under this form: BAD_NOT_CONNECTED. It can be taken using the **Quality** property (in .NET) or using the **getQuality** method (in C++).
    
-   the time the value was obtained, here called the **time stamp**. The time stamp indicates the time from 01.01.1601 in ticks of 100 ns and represents the time the value and quality was obtained by the device (if this is available) or the time the server updated or validated the value and quality in its CACHE. Note that if a device or server is checking a value every 10 seconds then the expected behavior would be that the timestamp of that value would be updated every 10 seconds (even if the value is not actually changing). Thus the time stamp reflects the time at which the server knew the corresponding value was accurate.
    
    It can be taken using the **TimeStamp** property (in .NET) or using the **getTimeStamp** method (in C++).