## **Compiling the OPC Toolkit core**

### Install the source code files

You install the OPC Toolkit core source code files by entering the source code license key to the Softing License Manager.

After you press the Enable button, the installation for the core files installs the files into the Windows/core/src directory.

### Adjust the OTB configuration

After you licensed all source code parts you have purchased, please open the OTB project file in the directory Windows/core/src/OTB.

We provide project files of Microsoft Visual Studio 2003 (OTB_VS2003.vcproj), Microsoft Visual Studio 2005 (OTB_VS2005.vcproj), Microsoft Visual Studio 2008 (OTB_VS2008.vcproj), Microsoft Visual Studio 2010 (OTB_VS2010.vcxproj), Microsoft Visual Studio 2012 (OTB_VS2012.vcxproj), Microsoft Visual Studio 2013 (OTB_VS2013.vcxproj), Microsoft Visual Studio 2015 (OTB_VS2015.vcxproj) and Microsoft Visual Studio 2017 (OTB_VS2017.vcxproj).

Before compiling you have to adjust the OTB configuration in the OTBcfg.h file. You have to comment out all OTB_PROD defines you have not purchased and

remove the comments from the define OTB_USER_COMPILED.
```
//-----------------------------------------------------------------------------
// Supported defines:
// 
//  OPC Toolkit Source Code Products:
//   OTB_PROD_DA_CLIENT    - OPC Toolkit DA Client Source Code
//   OTB_PROD_AE_CLIENT    - OPC Toolkit AE Client Source Code
//   OTB_PROD_XMLDA_CLIENT - OPC Toolkit XMLDA Client Source Code
//   OTB_PROD_DA_SERVER    - OPC Toolkit DA Server Source Code
//   OTB_PROD_AE_SERVER    - OPC Toolkit AE Server Source Code
//   OTB_PROD_XMLDA_SERVER - OPC Toolkit XMLDA Server Source Code
// 
//-----------------------------------------------------------------------------

#ifndef OTB_PROD_DA_CLIENT
#define OTB_PROD_DA_CLIENT
#endif
#ifndef OTB_PROD_XMLDA_CLIENT
#define OTB_PROD_XMLDA_CLIENT
#endif
#ifndef OTB_PROD_DA_SERVER
#define OTB_PROD_DA_SERVER
#endif
#ifndef OTB_PROD_XMLDA_SERVER
#define OTB_PROD_XMLDA_SERVER
#endif

#ifdef SOOS_WINDOWS
#ifndef OTB_PROD_AE_CLIENT
#define OTB_PROD_AE_CLIENT
#endif
#ifndef OTB_PROD_AE_SERVER
#define OTB_PROD_AE_SERVER
#endif
#endif // SOOS_WINDOWS

// Define this to compile the OTB
// #define OTB_USER_COMPILED
```
Then you have to open the file OTB.cpp and search for the function OTActivate.

Put // at the line !! YOU HAVE ..." and replace the !! ADD YOUR LICENSE CODE HERE !! by your binary license keys of the products you purchased.
```
#ifdef OTB_USER_COMPILED // the Softing version is inside the private file License.cpp !
LONG OTAPI_CALL OTActivate(IN BYTE feature, IN LPTSTR key) {

//!! YOU HAVE TO ADD YOUR LICENSE CODES IN THIS FUNCTION, and afterwards remove this line !!
    switch (feature)
    {
        case OTS_FEATURE_DA_SERVER:
            if (_tcscmp(key, _T("!! ADD YOUR LICENSE CODE HERE !!")) == 0) {
                return S_OK;
            }
        break;
        case OTS_FEATURE_XMLDA_SERVER:
            if (_tcscmp(key, _T("!! ADD YOUR LICENSE CODE HERE !!")) == 0) {
                return S_OK;
            }
        break;
        case OTC_FEATURE_DA_CLIENT:
            if (_tcscmp(key, _T("!! ADD YOUR LICENSE CODE HERE !!")) == 0) {
                return S_OK;
            }
        break;
        case OTC_FEATURE_XMLDA_CLIENT:
            if (_tcscmp(key, _T("!! ADD YOUR LICENSE CODE HERE !!")) == 0) {
                return S_OK;
            }
        break;
        case OTS_FEATURE_AE_SERVER:
            if (_tcscmp(key, _T("!! ADD YOUR LICENSE CODE HERE !!")) == 0) {
                return S_OK;
            }
        break;
        case OTC_FEATURE_AE_CLIENT:
            if (_tcscmp(key, _T("!! ADD YOUR LICENSE CODE HERE !!")) == 0) {
                return S_OK;
            }
        break;
    }
    return OT_E_INVALIDFEATURE;
}
#else
#include "private/License.cpp"
#endif
```


### Compile the OTB library

Now you can compile the OTB library using the Visual Studio build mechanism.

### Use the debug version of the OTB library in the OPC Toolkit .NET

For NET 1.1 and NET 2.0 projects, if you want to use the debug version of the OTB library in the OPC Toolkit .NET you have to open the file OTBFunctions.cs in the /Windows/NET/src directory.

Remove the comments from the OTBuD.dll and add comments to the OTBu.dll
```
#if !NET35 && !NET40 && !NET45
namespace Softing.OPCToolbox.OTB
{
    #region OTB functions

    internal class OTBFunctions
    {
#if DEBUG
    //const string  OTB_DLL = "OTBuD.dll";
    const string  OTB_DLL = "OTBu.dll";
#elif NDEBUG
    const string  OTB_DLL = "OTBu.dll";
#endif
    }
} // end namespace Softing.OPCToolbox.OTB

#else // !NET35 && !NET40 && !NET45
[...]
#endif // !NET35 && !NET40 && !NET45
```
For NET 3.5, NET 4.0 and NET 4.5 projects, if you want to use the debug version of the OTB library in the OPC Toolkit .NET you have to open the file OTBFunctions.cs in the /Windows/NET/src directory.

Remove the comments from the OTBuD.dll, OTBuDx64.dll and add comments to the OTBu.dll respectively OTBux64.dll
```
#if !NET35 && !NET40 && !NET45
[...]
#else // !NET35 && !NET40 && !NET45
namespace Softing.OPCToolbox.OTB_x86
{
    #region OTB functions

    internal class OTBFunctions
    {
#if DEBUG
    //const string  OTB_DLL = "OTBuD.dll";
    const string  OTB_DLL = "OTBu.dll";
#elif NDEBUG
    const string  OTB_DLL = "OTBu.dll";
#endif
[...]
    }
} // Softing.OPCToolbox.OTB_x86

namespace Softing.OPCToolbox.OTB_x64
{
    #region OTB functions

    internal class OTBFunctions
    {
#if DEBUG
    //const string  OTB_DLL = "OTBuDx64.dll";
    const string  OTB_DLL = "OTBux64.dll";
#elif NDEBUG
    const string  OTB_DLL = "OTBux64.dll";
#endif
[...]
    }
} // Softing.OPCToolbox.OTB_x64

namespace Softing.OPCToolbox.OTB
{
    [...]
} // end namespace Softing.OPCToolbox

#endif // !NET35 && !NET40 && !NET45
```
Then you have to rebuild the OPC Toolkit .NET assembly with the Microsoft Visual Studio.

