## **Concept**

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/Classes.jpg)

The UML class diagram above includes the most important classes of the OPC Toolkit client interface.

The singleton Application object is the toolkit's main entry point for the client application. It provides methods to add connections to create connections to Data Access servers (DaSession class) and to Alarms and Events servers (AeSession class).

A session object represents a connection to an OPC server which is identified by it's URL.

The session objects provide a many functions to access server functionality e.g. for browsing the address space of the server.

If a client wants to receive data change or event notifications it has to create subscription objects.

On a subscription to a Data Access server (DaSubscription class) the client has to specify which process values (DaItems class) should be monitored.

The subscription to a Alarms and Events server (AeSubscription class) maintains a list of all active and/or not acknowledged conditions (AeCondition class). The AeCondition class is derived from the AeEvent class.

All objects which the client creates in the server are derived from the ObjectSpaceElement class. This class implements a simple state machine for the abstraction of the object creation process in the server.
