## **Data control**



### What is the Data Control?

The Data Control addresses to the .NET developers. It can be used in any Windows Application of the Microsoft Visual Studio 2003, 2005, 2008, or 2010.

The Data Control is a custom collection that contains objects of type **ControlDaItem**. A ControlDaItem is the representation in the Softing OPC Toolkit for an OPC Item that is used in the context of the data control.

The user can bind this collection to Windows Forms Controls at run time.

###  Why use the Data Control?

Using the Data Control in a Windows Forms Application provides an easy and fast way to visualize the values of the ControlDaItems it contains or to be notified about the change of these values. This can be done after choosing through a simple interface the items whose values are to be visualized and after binding some Windows Forms controls to the selected items. This saves time and coding.

###  How to add the Data Control to your application?

-   **VS2003**
    
    Create a new .NET Windows Application.
    
    Go to the **Toolbox** window and select **Components**.
    
    Right click in the **Components** section.
    
    In the window that appears select **Add/Remove Items…**
    
    Click the **Browse** button of the **.NET Framework Components** tab.
    
    Select the path to the directory where the TBN11.dll is found on your computer.
    
    Select the TBN11.dll and then press **Open**.
    
    Press **OK**.
    
    Now in the Components section of the application’s Toolkit a new component exists: it is called **DataControl**.
    
-   **VS2005**
    
    Create a new Windows Forms Application.
    
    Go to the **Toolbox** window and select **Components**.
    
    Right click in the **Components** section.
    
    In the window that appears select **Choose Items…**.
    
    Click the **Browse** button of the **.NET Framework Components** tab.
    
    Select the path to the directory where the TBN20.dll is found on your computer.
    
    Select the TBN20.dll and then press **Open**.
    
    Press **OK**.
    
    Now in the Components section of the application’s Toolkit a new component exists: it is called **DataControl**.
    
-   **VS2008**
    
    Create a new Windows Forms Application.
    
    Go to the **Toolbox** window and select **Components**.
    
    Right click in the **Components** section.
    
    In the window that appears select **Choose Items…**.
    
    Click the **Browse** button of the **.NET Framework Components** tab.
    
    Select the path to the directory where the TBN35.dll is found on your computer.
    
    Select the TBN35.dll and then press **Open**.
    
    Press **OK**.
    
    Now in the Components section of the application’s Toolkit a new component exists: it is called **DataControl**.
    
-   **VS2010**
    
    Create a new Windows Forms Application.
    
    Go to the **Toolbox** window and select **Components**.
    
    Right click in the **Components** section.
    
    In the window that appears select **Choose Items…**.
    
    Click the **Browse** button of the **.NET Framework Components** tab.
    
    Select the path to the directory where the TBN40.dll is found on your computer.
    
    Select the TBN40.dll and then press **Open**.
    
    Press **OK**.
    
    Now in the Components section of the application’s Toolkit a new component exists: it is called **DataControl**.
    
-   **VS2012**
    
    Create a new Windows Forms Application.
    
    Go to the **Toolbox** window and select **Components**.
    
    Right click in the **Components** section.
    
    In the window that appears select **Choose Items…**.
    
    Click the **Browse** button of the **.NET Framework Components** tab.
    
    Select the path to the directory where the TBN45.dll is found on your computer.
    
    Select the TBN45.dll and then press **Open**.
    
    Press **OK**.
    
    Now in the Components section of the application’s Toolkit a new component exists: it is called **DataControl**.
    
-   **VS2013**
    
    Create a new Windows Forms Application.
    
    Go to the **Toolbox** window and select **Components**.
    
    Right click in the **Components** section.
    
    In the window that appears select **Choose Items…**.
    
    Click the **Browse** button of the **.NET Framework Components** tab.
    
    Select the path to the directory where the TBN451.dll is found on your computer.
    
    Select the TBN451.dll and then press **Open**.
    
    Press **OK**.
    
    Now in the Components section of the application’s Toolkit a new component exists: it is called **DataControl**.

### Note
```
Before trying to configure the DataControl, the OTBu.dll (or OTBuD.dll, if the Toolkit Core was built in debug 
after activating source-code license and the .NET API is configured to use the debug version of the Toolkit 
Core) must be placed both in the current project's folder (where the “.csproj” file is stored) and also in the 
project's output folder (usually bin\VS20XX\Release or bin\VS20XX\Debug).

For NET 3.5, NET 4.0 and NET 4.5 projects the OTBux64.dll (or OTBuDx64.dll, should the Toolkit Core have 
been build also in debug after activating source-code license and should the .NET API be configured to use the 
debug version of the Toolkit Core) must be included in the project output directory instead of the OTBu.dll if the 
building platform is x64 or AnyCPU on an x64 operating system.

If Visual Studio displays an error when opening the project form file - Unable to load DLL 'OTBu.dll': The 
specified module could not be found. (Exception from HRESULT: 0x8007007E) - the OTBu.dll should be copied 
in a folder added to the System Environment Path Variable (it might not be enough for the library to be 
copied to the project file and/or solution file fodler).
```

### How to configure the Data Control?

Drag and drop to your form the DataControl component from the Components section of the application’s Toolkit.

Right click on the DataControl and then choose Properties.

In the Properties Window select the **Session** property. Using this property you can set a client–server session that allows you to connect to a Data Access Server, create subscriptions and add items to the created subscriptions. For the items selected in this phase the server will send notification about value changes after the DataControl is started. Also Windows Controls can be bound to the values of these items.

Press the

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/Browse.PNG)

button of the Session property. Now a window will appear. This will allow you to configure the DataControl.

In the window that appears you can see two tabs: one is called **Server** and the other one is called **DaItems**. In the Server tab you can browse all the servers installed on the local or remote stations. The selected server’s URL will appear in the textbox placed at the bottom of the window. Selecting a server will signify that the items whose values you are interested in belong to that server.

### Note
```
The DataControl permits working with items belonging to a single server. If you are interested in monitoring 
items that belong to different servers than a DataControl will be added to the application for each server and 
configured according to your needs.
```
After choosing the Data Access server, select the **DaItems** tab. The figure below shows you how the DaItems page looks like at the beginning.

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/DaItems.jpg)

Three main areas exist in the **DaItems** page: one with the subscriptions currently added to the session, one with the items currently added to selected subscription and one for browsing the server’s address space.

-   The first area displays information on the subscriptions currently added to the server. Three button controls exist for adding/removing subscriptions to/from server or editing an existing subscription. The display gives information about subscription’s name, subscription’s active state, subscription’s update rate and the numbers of items currently added to the subscription.
### Note
```
Any session must have at least one subscription. After selecting a session, a subscription will be 
automatically added to it. It has the “Subscription1” name, 1000 ms update rate and 0 items added to 
it. It is also in the active state. When deleting subscriptions, all subscriptions can be deleted except the 
last one.
    
Two subscriptions with the same name cannot exist in the server. The new subscription must be 
different by the ones that already exist.
    
If a subscription’s active state is true then the server will notify the client about the value changes for 
the items that belong to the subscription. If a subscription’s active state is false the client won’t be 
informed about the value changes.
```

-   The second area displays information on the items belonging to the currently selected subscription. The item identifier, item data type and the access rights to the item are information given for each item. Two button controls exist for adding/removing items to/from the selected subscription. For adding items, a text box control exists to insert the identifier of the item to be added. If the identifier is a valid one (an item with this identifier exists in the server’s address space) then the item is added to the subscription and server will send notifications when its value changes. Otherwise the item will be added to the subscription but it will appear with a red color. No data about this item will be sent because the server has no knowledge about it.
    
-   The third area consists of two zones: the left one and the right one. The left zone is used for browsing the current server. All the nodes of the server’s address space will be displayed here in a hierarchical way. Selecting a node in the server’s address space will determine the right zone to be populated with all the items that belong to that node. Two button controls exist here too for adding/removing items to/from the selected subscription. All the items selected will be added /removed. To select an item just click on it. To select a group of items use CTRL + click on all the items you wish to select.
### Note
```
An item can be added/removed by double-clicking on it. If the item is not added (it has a grey color) by double clicking it will be added. If the item is already added (it has a bright green color) by double clicking it will be removed from the subscription.
```
Figure below shows how the DaItems page looks like after a set of items was added to the currently selected subscription.

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/AddingItems.jpg)

When an item is added to a subscription the node it belongs will change its color from grey to dark yellow. When all the items belonging to a node are added to a subscription, the node will change its color from grey or dark yellow to bright yellow. After you added subscriptions and items, in order to save the current configuration, press the OK button. If you press the Cancel button the configuration will be lost and the last saved configuration will be considered the current one.

###  How to start and stop the DataControl?

To use the functionality the DataControl provides it must first be started. This can be done using the Start method. The data binding can be performed only afterwards and notification about values changes for the items that belong to it will be received. When the DataControl must be stopped use the Stop method. After stopping the DataControl no notification about values changes for the items will be received. The Windows Controls bounded to the DataControl will display the value the items had before the stopping operation.

###  How to bind to a Windows Forms Control?

The DataControl can be bound to any Windows Forms Control that supports data binding.

The data binding is done at runtime using the **DataBindings** property of a Windows Forms Control.

Before the data binding is attempted, the DataControl must be started.

For data binding a new **Binding** object must be added to the data bindings of a Windows Forms Control. The binding command must be written manually.

###  Example

The following example shows how to bind the content of a TextBox Control to the **ValueToString** property of a **ControlDaItem** object. The ControlDaItem object has the “increment.UI1” name and belongs to the subscription called “Subscription1”.
### C#
```
textBox1.DataBindings.Add(
  new System.Windows.Forms.Binding(
    "Text",
    dataControl1.GetItem ("Subscription1","increment.UI1"),
    "ValueToString"));
```
### VB .NET
```
textBox1.DataBindings.Add( _
  New Binding( _
     "Text", _
     dataControl1.GetItem("Subscription1", "increment.UI1"), _
    "ValueToString"))
```

where:

**textBox1**

The Windows Forms Control that will display the item's value. It is the binding target object.

**Text**

The target property (it is a property of the TextBox Control).

**dataControl1**

A DataControl object.

**dataControl1.GetItem ("Subscription1","increment.UI1")**

The source object; it represents the item that has the "increment.UI1" identifier and belongs to the subscription named "Subscription1".

**ValueToString**

The value to use at binding.

As result of binding, the TextBox will contain the current value of the item “increment.UI1” that belongs to the subscription called “Subscription1”.

###  How to receive notification when an item's value changes?

The **DataChanged** event of the DataControl occurs every time a subscription from the ones added in the configuration phase raises a **DataChanged** event. The latter event occurs at a time interval equal with the subscription's update rate, only if at least one of the items that belong to the subscription change its value.

The method **ControlDataChangedEventHandler** handles the **DataChanged** event of the DataControl. The method has as parameters: the subscription to which the items belong. a list with the items that changed their values. a list with the new items’ values. a list with the results of value change.
### Note
```
The notification about the intems value's change will be received only for the items selected in the configuration 
phase!
```


These items must also belong to a subscription that is found in the active state. For further details about an object's state see [Object States](a8025f60-ae57-4a39-8620-74379c3962a7.htm).

###  Licensing
After adding the DataControl to the application, please introduce the license key in the Property window of the DataControl, for properties **BinaryLicenseDa** and **BinaryLicenseXmlDa