## **Getting the status**

In the toolkit, the **DaSession** and **AeSession** objects exist for getting information on the status of a Data Access respectively an Alarms and Events server. The method is called **GetStatus** and it returns to the client a **ServerStatus** object that contains information about the server.

The following information about a server is returned:

-   Vendor information - Information about the server's manufacturer
    
-   State - The current status of the server, i.e. running
    
-   Start time - The time when the server started
    
-   Current time - The time in the server when the method GetStatus was called
    
-   Supported locale Ids - The list with all the languages supported by the server
    
-   Last update time - The time when the last data was sent to the client by callback
    
-   Group count - The total number of subscriptions that clients have created in the server
    
-   Bandwidth - The processor performance consumed by the server
    
-   Status information - The text that describes the current server state
    

For a detailed example on how to get a Data Access server status, check the **DAConsole** example. For a detailed example on how to get an Alarms and Events server status, check the **AEConsole** example.