## **Concept**
The UML class diagrams below include the most important classes of the OPC Toolkit server interface.

###  Address space

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/Classes.jpg)

The singleton Application object is the Toolkit's main entry point for the server application.

The server application can specify the process values (DaAddessSpaceElement class) and the alarms sources (AeAddressSpaceElement class) of the server by building an object tree below the address space root objects.

If this configuration information of the server is already stored somewhere else the application can overload the query methods on the address space root objects to collect the information on demand.

A client can use the address space browse interface to access the address space elements of the server.

###  Data Access I/O

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/Classes2.jpg)

The server application can specify per process value (DaAddressSpaceElement class) if the read operations on the value should be performed by asking the application (poll) or by taking the lastest value the application stored for the process value (report).

If a value has to be polled the toolkit creates a request (DaRequest class) for reading the value. All requests issues by one read call from a client or created by the toolkit for updating a subscription are collected in a transaction (DaTransaction class).

Write operations will allways be handled by creating requests and transactions.
###  Alarms and Events conditions

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/Classes3.jpg)


The toolkit maintains the list of all active and/or not acknowledged conditions of the server in the condition list of the application object.

A condition belongs to a category. The categories, their condition names and attributes can be queried by the client.
