## **Windows Firewall rule for XML-DA Servers**

Configuring Windows Firewall is a required task if the OPC Server to be deployed is an XML-DA OPC Server. This bread of OPC Servers acts like a WEB server, receiving and serving SOAP telegrams from/to the OPC XML-DA Clients.

Adding a Windows Firewall rule to allow inbound traffic to this OPC Server is a must of the OPC XML-DA Server will not be reachable over the XML-DA protocol by remote clients.

### Note
```
Adding / modifying / deleting Windows Firewall rules requires administrative priviledges. Please make sure the 
deployment process has the appropriate rights in perfroming the Windows Firewall rule operations.
```
Adding an inbound Windows Firewall rule can be accomplished either by using the **netsh** command-line tool or by manually adding a rule through the Windows Firewall Microsoft Management Console GUI.


**Adding a Windows Firewall rule programatically:**
```
netsh.exe advfirewall firewall add rule name="Firewall-rule-name" dir=in action=allow program="Full-path-to-OPC-XML-DA-Server"
```
**Removing a Windows Firewall rule programatically:**

```
netsh.exe advfirewall firewall delete rule name="Firewall-rule-name"
```
In order to add a Windows Firewall inbound rule, follow the steps below:

-   Open **Windows Firewall** applet from Control Panel;
-   In the left side of the newly opened Windows Firewall window, select **Advanced settings**;
-   In the left side of the newly opened Windows Firewall with Advanced Security window, select **Inbound Rules**;
-   Use the **Action** menu and select the **New Rule...** command then follow the **New Inbound Rule Wizard**, adding a Program Rule and providing the full path to the deployed OPC XML-DA Server.

![OPC-Classic-SDK](https://github.com/SoftingIndustrial/OPC-Classic-SDK/raw/main/documentation_pics/WindowsFirewallNewRule.png)


Removing a previously-created Windows Firewall rule can be done by selecting the respecting Windows Firewall rule in the central panel (usually the rule is at the top of the list) and selecting **Delete** from the **Action** menu or from the respective rule`s contextual menu.