## **DCOM Configuration for OPC Clients**

### Note
```
Administrative priviledges are required to perform the following Windows DCOM Security configuration.
```
If the deployed OPC Application is an OPC DA/AE Client, the Windows DCOM Security must be configured to allow OPC Servers to invoke callbacks.

The OPC DA/AE Client DCOM Security configuration is required as the remote OPC DA/AE Server may invoke callbacks for any operation that the client requested asynchronously and also to notify the client about occurring data changes, if the client asked for such notifications.

It is reccommended that the DCOM Security settings to be configured in a very secured way in order to avoid unauthorized access.

### Note
```
There is no need in configuring the Windows DCOM Securty settings for local OPC DA/AE Clients connecting to local 
OPC DA/AE Servers. Also, pure OPC XML-DA Clients/Servers do not require DCOM configuration.
```

The "OPC DA/AE Client" will be further referred to as "OPC Client" and the "OPC DA/AE Server" will be further referred to as "OPC Server". Also, the "Domain/Workgroup user" will be further referred to as "user".

For an OPC Client machine, the only affected DCOM Security section is **Access Permissions**. This section decides "as which user" the remote OPC Server has the right to invoke callbacks in the local OPC Client, once the local OPC Client successfully connected to the remote OPC Server.

The following steps must be followed to properly configure the Windows DCOM Security settings on a machine where an OPC Client is to be deployed:

-   Open the **Component Services** addin from the Control Panel or simply run **DCOMCNFG.EXE**;
-   Expand the (left panel) **Console Root**, expand the **Component Services**, expand the **Computer** and then select **Properties** from the **My Computer** contextual menu;
-   In the newly opened **My Computer Properties** window, select the **Default Properties** tab and make sure the following settings are configured (default Windows settings):
    -   **Enable Distributed COM on this computer** - checked
    -   **Default Authentication Level** - Connect
    -   **Default Impersonation Level** - Identify
-   Select the **COM Security** tab and perform the following operations:
    -   Click the **Edit Limits...** button and in the newly opened **Access Permissions** window add the required users with both **Local Access** and **Remote Access** rights then press OK;
    -   Click the **Edit Default...** button and in the newly opened **Access Permissions** window add the required users with both **Local Access** and **Remote Access** rights then press OK;

### Note
```
Make sure that the users under which the remote OPC Servers are running are added to the above 
section.
```

-   Close the **My Computer Properties** window by pressing OK.

For more information on General Windows DCOM Security settings please see the [DCOM Configuration](6674f8ee-0d1c-484c-afdb-26d7231e089e.htm) chapter from the Installation section.

### Note
```
Local OPC Clients may not be remotely started through DCOM under any circumstances. Only local OPC Servers 
(DCOM registered classes) may be remotely started by remote OPC Clients if the user the remote OPC Client runs 
under has enough priviledges on the local OPC Server machine.
```
### Note
```
No remote application may invoke callbacks in a local OPC Client if the local OPC Client did not expressly connected 
to the respective remote application.
```

### Note
```
If the local OPC Client fails to connect to the remote OPC Server, it is not possible for the the remote OPC Server to invoke any callback in the local OPC Client.
```
The most secured way of configuring DCOM Security settings on a Windows machine where an OPC Client runs is to only grant remote access permissions to the user the remote OPC Servers run under. If the client will connect to more than one remote OPC Server, all the users (or the group containing these users) the remote OPC Servers run under must be granted the remote access permission. Each action of each user may be audited.

The most insecured way of configuring Windows DCOM Security settings where an OPC Client runs is to grant remote access permissions to the special "ANONYMOUS LOGON", "Everyone", "Network" and "SYSTEM" Windows Users Accounts. Although this security configuration seems insecure, it only allows OPC Servers, to which an OPC Client connected to, to invoke callbacks to the respective OPC Client. No remote launch or remote activation rights are touched.