## **EnumQuality Enumeration**

**Namespace:** [Softing.OPCToolbox](N_Softing_OPCToolbox.htm)  
**Assembly:** TBN40 (in TBN40.dll) Version: 4.47.1.3920 (4.47.1.3920)

### Syntax

#### Unmanaged C++
```
typedef enum tagEnumQuality{	}EnumQuality;
```
#### C#
```
public enum EnumQuality
```

#### Visual Basic
```
Public Enumeration EnumQuality
```
#### Visual C++
```
public enum class EnumQuality
```

### Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
GOOD|192|The value is good.
GOOD\_LOCAL\_OVERRIDE|216|The value has been overridden. Typically this means that the input has been disconnected and a manually value has been forced.
BAD|0|The value is bad but no specific reason is known.
BAD\_CONFIG\_ERROR|4|There is a server specific problem with the configuration.
BAD\_NOT\_CONNECTED|8|The input is required to be logically connected to something but the connection couldn't be established.
BAD\_DEVICE\_FAILURE|12|A device failure has been detected.
BAD\_SENSOR\_FAILURE|16|A sensor failure has been detected .
BAD\_LAST\_KNOWN|20|Communications have failed. However, the last known value is available.
BAD\_COMM\_FAILURE|24|Communications have failed. No last known value is available.
BAD\_OUT\_OF\_SERVICE|28|The block is off scan or otherwise locked.
BAD\_WAITING\_FOR\_INITIAL\_DATA|32|The initial quality for the data items added to a subscription.
UNCERTAIN|64|There is no specific reason why the value is uncertain.
UNCERTAIN\_LAST\_USABLE|68|The last usable value.
UNCERTAIN\_SENSOR\_CAL|80|Either the value has pegged at one of the sensor limits (in which case the limit field should be set to 1 or 2) or the sensor is otherwise known to be out of calibration.
UNCERTAIN\_EGU\_EXCEEDED|84|The returned value is outside the limits defined for this parameter. Note that in this case the limit flag indicates which limit has been exceeded.
UNCERTAIN\_EGU\_EXCEEDED\_LOW|85|The returned value is under the limit defined for this parameter.
UNCERTAIN\_EGU\_EXCEEDED\_HIGH|86|The returned value is over the limit defined for this parameter.
UNCERTAIN\_SUB\_NORMAL|88|The value is derived from multiple sources and has less than the required number of good sources.
QUALITY\_NOT\_SET|65535|The quality is not set.


### Unmanaged Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
EnumQuality\_ GOOD|192|The value is good.
EnumQuality\_ GOOD\_LOCAL\_OVERRIDE|216|The value has been overridden. Typically this means that the input has been disconnected and a manually value has been forced.
EnumQuality\_ BAD|0|The value is bad but no specific reason is known.
EnumQuality\_ BAD\_CONFIG\_ERROR|4|There is a server specific problem with the configuration.
EnumQuality\_ BAD\_NOT\_CONNECTED|8|The input is required to be logically connected to something but the connection couldn't be established.
EnumQuality\_ BAD\_DEVICE\_FAILURE|12|A device failure has been detected.
EnumQuality\_ BAD\_SENSOR\_FAILURE|16|A sensor failure has been detected .
EnumQuality\_ BAD\_LAST\_KNOWN|20|Communications have failed. However, the last known value is available.
EnumQuality\_ BAD\_COMM\_FAILURE|24|Communications have failed. No last known value is available.
EnumQuality\_ BAD\_OUT\_OF\_SERVICE|28|The block is off scan or otherwise locked.
EnumQuality\_ BAD\_WAITING\_FOR\_INITIAL\_DATA|32|The initial quality for the data items added to a subscription.
EnumQuality\_ UNCERTAIN|64|There is no specific reason why the value is uncertain.
EnumQuality\_ UNCERTAIN\_LAST\_USABLE|68|The last usable value.
EnumQuality\_ UNCERTAIN\_SENSOR\_CAL|80|Either the value has pegged at one of the sensor limits (in which case the limit field should be set to 1 or 2) or the sensor is otherwise known to be out of calibration.
EnumQuality\_ UNCERTAIN\_EGU\_EXCEEDED|84|The returned value is outside the limits defined for this parameter. Note that in this case the limit flag indicates which limit has been exceeded.
EnumQuality\_ UNCERTAIN\_EGU\_EXCEEDED\_LOW|85|The returned value is under the limit defined for this parameter.
EnumQuality\_ UNCERTAIN\_EGU\_EXCEEDED\_HIGH|86|The returned value is over the limit defined for this parameter.
EnumQuality\_ UNCERTAIN\_SUB\_NORMAL|88|The value is derived from multiple sources and has less than the required number of good sources.
EnumQuality\_ QUALITY\_NOT\_SET|65535|The quality is not set.

### See Also

[Softing.OPCToolbox Namespace](N_Softing_OPCToolbox.htm)