## **TraceEventHandler Delegate**

This will be triggered from within the Toolkit core when a trace message needs to be delivered to the custom application. The user now may use this Toolkit core trace messages in the propertaty logging mechanism.

**Unmanaged C++** Delegate is not available for Unmanaged C++.

**Unmanaged C++** A function pointer definition is used for the calback receive purpose in C++typedef void (API_CALL *TraceEventHandler)(IN tstring aTraceString,IN unsigned short aLevel,IN unsigned long aMask,IN tstring anObjId,IN tstring aText);

**C#, Visual Basic, C++** Represents the method that will handle the [TraceOutput](E_Softing_OPCToolbox_Client_Application_TraceOutput.htm) event of an [Application](T_Softing_OPCToolbox_Client_Application.htm).

**Namespace:** [Softing.OPCToolbox](N_Softing_OPCToolbox.htm)  
**Assembly:** TBN40 (in TBN40.dll) Version: 4.47.1.3920 (4.47.1.3920)

### Syntax

#### Unmanaged C++
```
	
```
#### C#
```
public delegate void TraceEventHandler(
	string traceString,
	EnumTraceLevel traceLevel,
	EnumTraceGroup traceGroup,
	string objectId,
	string message
)

```

#### Visual Basic
```
Public Delegate Sub TraceEventHandler ( _
	traceString As String, _
	traceLevel As EnumTraceLevel, _
	traceGroup As EnumTraceGroup, _
	objectId As String, _
	message As String _
)

```
#### Visual C++
```
public delegate void TraceEventHandler(
	String^ traceString, 
	EnumTraceLevel traceLevel, 
	EnumTraceGroup traceGroup, 
	String^ objectId, 
	String^ message
)

```

#### Parameters

traceString
Type: System.String
A string related to the trace.

traceLevel
Type: Softing.OPCToolbox.EnumTraceLevel
The level of tracing.

traceGroup
Type: Softing.OPCToolbox.EnumTraceGroup
The group to be traced.

objectId
Type: System.String
An identifier for the traced object.

message
Type: System.String
The tracing message.

### See Also

[Softing.OPCToolbox Namespace](N_Softing_OPCToolbox.htm)