## **EnumConditionChange Enumeration**


Describes which properties of the condition have been changed causing the server to send an event notification.

**Namespace:** [Softing.OPCToolbox](N_Softing_OPCToolbox.htm)  
**Assembly:** TBN40 (in TBN40.dll) Version: 4.47.1.3920 (4.47.1.3920)

### Syntax

#### Unmanaged C++
```
typedef enum tagEnumExecutionType{  
	}EnumConditionChange;
```
#### C#
```
public enum EnumConditionChange
```

#### Visual Basic
```
Public Enumeration EnumConditionChange
```
#### Visual C++
```
public enum class EnumConditionChange
```

### Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
ACTIVE\_STATE|1|The condition’s active state has changed.
ACK\_STATE|2|The condition’s acknowledgment state has changed.
ENABLE\_STATE|4|The condition’s enabled state has changed.
STATE|7|The condition’s state has changed.
QUALITY|8|The condition's quality has changed.
SEVERITY|16|The severity level has changed.
SUBCONDITION|32|The condition has transitioned into a new sub-condition.
MESSAGE|64|The event message has changed (compared to prior event notifications related to this condition).
ATTRIBUTE|128|One or more event attributes have changed (compared to prior event notifications related to this condition).
ACK\_DATA|32768|The condition’s acknowledgment data has changed.

### Unmanaged Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
EnumConditionChange\_ ACTIVE\_STATE|1|The condition’s active state has changed.
EnumConditionChange\_ ACK\_STATE|2|The condition’s acknowledgment state has changed.
EnumConditionChange\_ ENABLE\_STATE|4|The condition’s enabled state has changed.
EnumConditionChange\_ STATE|7|The condition’s state has changed.
EnumConditionChange\_ QUALITY|8|The condition's quality has changed.
EnumConditionChange\_ SEVERITY|16|The severity level has changed.
EnumConditionChange\_ SUBCONDITION|32|The condition has transitioned into a new sub-condition.
EnumConditionChange\_ MESSAGE|64|The event message has changed (compared to prior event notifications related to this condition).
EnumConditionChange\_ ATTRIBUTE|128|One or more event attributes have changed (compared to prior event notifications related to this condition).
EnumConditionChange\_ ACK\_DATA|32768|The condition’s acknowledgment data has changed.

### See Also
[Softing.OPCToolbox Namespace](N_Softing_OPCToolbox.htm)