## **EnumEventType Enumeration**

**Namespace:** [Softing.OPCToolbox](N_Softing_OPCToolbox.htm)  
**Assembly:** TBN40 (in TBN40.dll) Version: 4.47.1.3920 (4.47.1.3920)

### Syntax

#### Unmanaged C++
```
typedef enum tagEnumEventType{	}EnumEventType;
```
#### C#
```
public enum EnumEventType
```

#### Visual Basic
```
Public Enumeration EnumEventType
```
#### Visual C++
```
public enum class EnumEventType
```

### Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
SIMPLE|1|This event type is used to notify the occurence of simple events (e.g. failure of a device) to the client.
TRACKING|2|The events of this type represent the occurrences which involve some interference from outside the server and which result in a value change of a process parameter. An example is setting of a new limit value for a process variable by a client.
CONDITION|4|The events of this type are always associated with a condition. They are fired as a result of a state change of this condition (e.g. active/inactive). Exceeding a limit is an example for such kind of an event.

### Unmanaged Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
EnumEventType\_ SIMPLE|1|This event type is used to notify the occurence of simple events (e.g. failure of a device) to the client.
EnumEventType\_ TRACKING|2|The events of this type represent the occurrences which involve some interference from outside the server and which result in a value change of a process parameter. An example is setting of a new limit value for a process variable by a client.
EnumEventType\_ CONDITION|4|The events of this type are always associated with a condition. They are fired as a result of a state change of this condition (e.g. active/inactive). Exceeding a limit is an example for such kind of an event.

### See Also

[Softing.OPCToolbox Namespace](N_Softing_OPCToolbox.htm)