## **EnumPropertyId Enumeration**

**Namespace:** [Softing.OPCToolbox](N_Softing_OPCToolbox.htm)  
**Assembly:** TBN40 (in TBN40.dll) Version: 4.47.1.3920 (4.47.1.3920)

### Syntax

#### Unmanaged C++
```
typedef enum tagEnumPropertyId{	}EnumPropertyId;
```
#### C#
```
public enum EnumPropertyId
```

#### Visual Basic
```
Public Enumeration EnumPropertyId
```
#### Visual C++
```
public enum class EnumPropertyId
```

### Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
ITEM\_CANONICAL\_DATATYPE|1|Item canonical datatype (VT I2).
ITEM\_VALUE|2|Item value (variant).
ITEM\_QUALITY|3|Item quality (VT I2).
ITEM\_TIMESTAMP|4|Item timestamp (VT DATE).
ITEM\_ACCESS\_RIGHTS|5|Item access rights (VT I4).
SERVER\_SCAN\_RATE|6|Server scan rate in milliseconds(VT R4).
ITEM\_EU\_TYPE|7|Item EU type (VT I4).
ITEM\_EU\_INFO|8|Item EUInfo (VT BSTR|VT ARRAY). If Item 7 "Item EU Type" is "Enumerated" - EUInfo will contain a SAFEARRAY of strings (Example: "OPEN", "CLOSE", "IN", "TRANSIT" etc.) corresponding to numeric values (0,1,2,etc.)
RESERVED\_RANGE\_1|9|Reserved for future OPC use (9-99 dec).
EU\_UNITS|100|EU Units (VT BSTR). E.g. "DEGC" or "GALLONS"
ITEM\_DESCRIPTION|101|Item description (VT BSTR). E.g. "Evaporator 6 Coolant Temp"
HIGH\_EU|102|High EU (VT R8). Present only for 'analog' data. This represents the highest value likely to be obtained in normal operation and is intended for such use as automatically scaling a bargraph display e.g. 1400.0
LOW\_EU|103|Low EU (VT R8). Present only for 'analog' data. This represents the lowest value likely to be obtained in normal operation and is intended for such use as automatically scaling a bargraph display e.g. 1400.0
HIGH\_INSTRUMENT\_RANGE|104|High Instrument Range (VT R8). Present only for 'analog' data. This represents the highest value that can be returned by the instrument e.g. 9999.9
LOW\_INSTRUMENT\_RANGE|105|Low Instrument Range (VT R8). Present only for 'analog' data. This represents the lowest value that can be returned by the instrument e.g. -9999.9
CONTACT\_CLOSE\_LABEL|106|Contact close label (VT BSTR). Present only for 'discrete' data. This represents a string to be associated with this contact when it is in the closed (non-zero) state e.g. "RUN", "CLOSE", "ENABLE", "SAFE", etc.
CONTACT\_OPEN\_LABEL|107|Contact open label (VT BSTR). Present only for 'discrete' data. This represents a string to be associated with this contact when it is in the opened (non-zero) state e.g. "RUN", "CLOSE", "ENABLE", "SAFE", etc.
ITEM\_TIMEZONE|108|Item timezone (VT I4). The difference in minutes between the items UTC timestamp and the local time in which the item value was obtained.
RESERVED\_RANGE\_2|109|Reserved for future OPC use. (109-199 dec)
CONDITION\_STATUS|300|Condition status (VT BSTR). The current alarm or condition status associated with the item e.g. "NORMAL", "ACTIVE"
ALARM\_QUICK\_HELP|301|Alarm quick help (VT BSTR). A short text string providing a brief set of instructions for the operator to follow when this alarm occurs.
ALARM\_AREA\_LIST|302|Alarm area list (VT BSTR|VT ARRAY). An array of strings indicating the plant or alarm areas which include this item ID
PRIMARY\_ALARM\_AREA|303|Primary alarm area (VT BSTR). A string indicating the primary plant or alrm area including this item ID
CONDITION\_LOGIC|304|Condition logic (VT BSTR). An aribtrary string describing the test being performed e.g. "High Limit exceeded"
LIMIT\_EXCEEDED|305|Limit exceeded (VT BSTR). For mulitstate alarms, the condition exceeded e.g. HIHI, HI, LO, LOLO
DEADBAND|306|Deadband (VT R8).
HIHI\_LIMIT|307|HiHi Limit (VT R8).
HI\_LIMIT|308|Hi Limit (VT R8).
LO\_LIMIT|309|Lo Limit (VT R8).
LOLO\_LIMIT|310|LoLo Limit (VT R8).
RATE\_OF\_CHANGE\_LIMIT|311|Rate of Change Limit (VT R8).
DEVIATION\_LIMIT|312|Deviation Limit (VT R8).
SOUND\_FILE|313|Sound file (VT BSTR). e.g. C:\MEDIA\FIC101.WAV, or MID
RESERVED\_RANGE\_3|320|Reserved for future OPC Alarms and Events use (314-399 dec). Additional IDs may be added without revising the interface ID.
RESERVED\_RANGE\_4|400|Reserved for future OPC use (400-4999). Additional IDs may be added without revising the interface ID.

### Unmanaged Members
**Member name**|**Value**|**Description**
:-----:|:-----:|:-----:
EnumPropertyId\_ ITEM\_CANONICAL\_DATATYPE|1|Item canonical datatype (VT I2).
EnumPropertyId\_ ITEM\_VALUE|2|Item value (variant).
EnumPropertyId\_ ITEM\_QUALITY|3|Item quality (VT I2).
EnumPropertyId\_ ITEM\_TIMESTAMP|4|Item timestamp (VT DATE).
EnumPropertyId\_ ITEM\_ACCESS\_RIGHTS|5|Item access rights (VT I4).
EnumPropertyId\_ SERVER\_SCAN\_RATE|6|Server scan rate in milliseconds(VT R4).
EnumPropertyId\_ ITEM\_EU\_TYPE|7|Item EU type (VT I4).
EnumPropertyId\_ ITEM\_EU\_INFO|8|Item EUInfo (VT BSTR|VT ARRAY). If Item 7 "Item EU Type" is "Enumerated" - EUInfo will contain a SAFEARRAY of strings (Example: "OPEN", "CLOSE", "IN", "TRANSIT" etc.) corresponding to numeric values (0,1,2,etc.)
EnumPropertyId\_ RESERVED\_RANGE\_1|9|Reserved for future OPC use (9-99 dec).
EnumPropertyId\_ EU\_UNITS|100|EU Units (VT BSTR). E.g. "DEGC" or "GALLONS"
EnumPropertyId\_ ITEM\_DESCRIPTION|101|Item description (VT BSTR). E.g. "Evaporator 6 Coolant Temp"
EnumPropertyId\_ HIGH\_EU|102|High EU (VT R8). Present only for 'analog' data. This represents the highest value likely to be obtained in normal operation and is intended for such use as automatically scaling a bargraph display e.g. 1400.0
EnumPropertyId\_ LOW\_EU|103|Low EU (VT R8). Present only for 'analog' data. This represents the lowest value likely to be obtained in normal operation and is intended for such use as automatically scaling a bargraph display e.g. 1400.0
EnumPropertyId\_ HIGH\_INSTRUMENT\_RANGE|104|High Instrument Range (VT R8). Present only for 'analog' data. This represents the highest value that can be returned by the instrument e.g. 9999.9
EnumPropertyId\_ LOW\_INSTRUMENT\_RANGE|105|Low Instrument Range (VT R8). Present only for 'analog' data. This represents the lowest value that can be returned by the instrument e.g. -9999.9
EnumPropertyId\_ CONTACT\_CLOSE\_LABEL|106|Contact close label (VT BSTR). Present only for 'discrete' data. This represents a string to be associated with this contact when it is in the closed (non-zero) state e.g. "RUN", "CLOSE", "ENABLE", "SAFE", etc.
EnumPropertyId\_ CONTACT\_OPEN\_LABEL|107|Contact open label (VT BSTR). Present only for 'discrete' data. This represents a string to be associated with this contact when it is in the opened (non-zero) state e.g. "RUN", "CLOSE", "ENABLE", "SAFE", etc.
EnumPropertyId\_ ITEM\_TIMEZONE|108|Item timezone (VT I4). The difference in minutes between the items UTC timestamp and the local time in which the item value was obtained.
EnumPropertyId\_ RESERVED\_RANGE\_2|109|Reserved for future OPC use. (109-199 dec)
EnumPropertyId\_ CONDITION\_STATUS|300|Condition status (VT BSTR). The current alarm or condition status associated with the item e.g. "NORMAL", "ACTIVE"
EnumPropertyId\_ ALARM\_QUICK\_HELP|301|Alarm quick help (VT BSTR). A short text string providing a brief set of instructions for the operator to follow when this alarm occurs.
EnumPropertyId\_ ALARM\_AREA\_LIST|302|Alarm area list (VT BSTR|VT ARRAY). An array of strings indicating the plant or alarm areas which include this item ID
EnumPropertyId\_ PRIMARY\_ALARM\_AREA|303|Primary alarm area (VT BSTR). A string indicating the primary plant or alrm area including this item ID
EnumPropertyId\_ CONDITION\_LOGIC|304|Condition logic (VT BSTR). An aribtrary string describing the test being performed e.g. "High Limit exceeded"
EnumPropertyId\_ LIMIT\_EXCEEDED|305|Limit exceeded (VT BSTR). For mulitstate alarms, the condition exceeded e.g. HIHI, HI, LO, LOLO
EnumPropertyId\_ DEADBAND|306|Deadband (VT R8).
EnumPropertyId\_ HIHI\_LIMIT|307|HiHi Limit (VT R8).
EnumPropertyId\_ HI\_LIMIT|308|Hi Limit (VT R8).
EnumPropertyId\_ LO\_LIMIT|309|Lo Limit (VT R8).
EnumPropertyId\_ LOLO\_LIMIT|310|LoLo Limit (VT R8).
EnumPropertyId\_ RATE\_OF\_CHANGE\_LIMIT|311|Rate of Change Limit (VT R8).
EnumPropertyId\_ DEVIATION\_LIMIT|312|Deviation Limit (VT R8).
EnumPropertyId\_ SOUND\_FILE|313|Sound file (VT BSTR). e.g. C:\MEDIA\FIC101.WAV, or MID
EnumPropertyId\_ RESERVED\_RANGE\_3|320|Reserved for future OPC Alarms and Events use (314-399 dec). Additional IDs may be added without revising the interface ID.
EnumPropertyId\_ RESERVED\_RANGE\_4|400|Reserved for future OPC use (400-4999). Additional IDs may be added without revising the interface ID.

### See Also

[Softing.OPCToolbox Namespace](N_Softing_OPCToolbox.htm)